(* Copyright (c) 2011 - 2015. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets"
     and
   "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook2
*)
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, DBClient, Grids, DBGrids, ExtCtrls, DBCtrls, Provider,
  FireDAC.Comp.Client,
  FireDAC.Comp.DataSet,
  FireDAC.Comp.UI,
  FireDAC.DApt,
  FireDAC.DApt.Intf,
  FireDAC.DatS,
  FireDAC.Phys,
  FireDAC.Phys.IB,
  FireDAC.Phys.IBBase,
  FireDAC.Phys.Intf,
  FireDAC.Stan.Async,
  FireDAC.Stan.Def,
  FireDAC.Stan.Error,
  FireDAC.Stan.Intf,
  FireDAC.Stan.Option,
  FireDAC.Stan.Param,
  FireDAC.Stan.Pool,
  FireDAC.UI.Intf,
  {$IF CompilerVersion < 28}
  // nothing needed
  {$ELSE}
  FireDAC.Phys.IBDef,
  {$ENDIF}
  FireDAC.VCLUI.Wait;

type
  TForm1 = class(TForm)
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    PopupMenu1: TPopupMenu;
    Aboutthiscustomer1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    VisitwwwDephiDevelperDayscom1: TMenuItem;
    VisitwwwJensenDataSystemscom1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    DataSetProvider1: TDataSetProvider;
    Create1: TMenuItem;
    NewAggregateField1: TMenuItem;
    ClientDataSet1CustomerTotal: TAggregateField;
    FDConnection1: TFDConnection;
    FDQuery1: TFDQuery;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    procedure Aboutthiscustomer1Click(Sender: TObject);
    procedure ClientDataSet1CustomerTotalGetText(Sender: TField;
      var Text: String; DisplayText: Boolean);
    procedure About1Click(Sender: TObject);
    procedure VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
    procedure VisitwwwJensenDataSystemscom1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ClientDataSet1CustNoGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure NewAggregateField1Click(Sender: TObject);
    procedure ClientDataSet1GetNumberSales(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure ClientDataSet1AfterOpen(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ShellApi; //for ShellExecute

procedure TForm1.Aboutthiscustomer1Click(Sender: TObject);
begin
ShowMessage('The average sale to this customer is ' +
  Format('%.2m', [StrToFloat(ClientDataSet1.Aggregates[0].Value)]) +
  '. The first sale to this customer was on '+
  DateToStr(ClientDataSet1.Aggregates[1].Value));
end;

procedure TForm1.ClientDataSet1CustomerTotalGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbLast in ClientDataSet1.GetGroupState(1) then
    Text := Format('%.2m',[StrToFloat(Sender.Value)])
  else
    Text := '';
end;

procedure TForm1.ClientDataSet1GetNumberSales(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbLast in ClientDataSet1.GetGroupState(1) then
    Text := Sender.Value
  else
    Text := '';
end;


procedure TForm1.ClientDataSet1AfterOpen(DataSet: TDataSet);
begin
  //Hook up the OnGetText event handler
  ClientDataSet1.FieldByName('CUSTNO').OnGetText :=
    ClientDataSet1CustNoGetText;
end;

procedure TForm1.ClientDataSet1CustNoGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbFirst in ClientDataSet1.GetGroupState(1) then
    Text := Sender.Value
  else
    Text := '';
end;

procedure TForm1.About1Click(Sender: TObject);
begin
ShowMessage('CDSAggs (c) 2002 Cary Jensen, Jensen Data Systems, Inc. '
  + #10#13 + ''
  + #10#13 + 'Demonstration of how to use aggregate fields, aggregates, and group state.'
  + #10#13 + 'This project is provided for demonstration purposes only.'
  + #10#13 + ''
  + #10#13 + 'Visit http://www.JensenDataSystems.com for information about training and consulting services.');
end;

procedure TForm1.VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.DelphiDeveloperDays.com', nil, nil, SW_SHOW);
end;

procedure TForm1.VisitwwwJensenDataSystemscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.JensenDataSystems.com', nil, nil, SW_SHOW);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Self.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  DataDir: string;
begin
  DataDir := GetEnvironmentVariable('DEMOSDIR');
  if DataDir.IsEmpty then
  begin
    ShowMessage('DEMOSDIR environment variable is not set. ' +
                'Cannot continue. See Appendix A, Setting the ' +
                'DEMOSDIR environment variable for more information');
    exit;
  end;

  FDConnection1.Params.Clear;
  FDConnection1.Params.Add('DriverID=IB');
  FDConnection1.Params.Add('Database=' +
    GetEnvironmentVariable('DEMOSDIR') + 'Data\dbdemos.gdb');
  FDConnection1.Params.Add('User_Name=sysdba');
  FDConnection1.Params.Add('password=masterkey');
  FDConnection1.Params.Add('Server=localhost');
  FDCOnnection1.LoginPrompt := False;
end;

procedure TForm1.NewAggregateField1Click(Sender: TObject);
begin
  ClientDataSet1.DisableControls;
  ClientDataSet1.Close;
  try
    with TAggregateField.Create(Self) do
    begin
      FieldName := 'NumberOfSales';
      Expression := 'COUNT(OrderNo)';
      IndexName := 'CustIdx';
      GroupingLevel := 1;
      Active := True;
      Visible := True;
      Name := 'ClientDataSet1NumberOfSales';
      DataSet := ClientDataSet1;
    end;
    with DBGrid1.Columns.Add do
    begin
      FieldName := 'NumberOfSales';
      Title.Caption := 'Number of Sales';
      Index := 6;
     end;
    //Hook up the OnGetText event handler
    ClientDataSet1.FieldByName('NumberOfSales').OnGetText :=
      ClientDataSet1GetNumberSales;
    //Disable the menu to that creates the new AggregateField
    Create1.Enabled := False;
  finally
    //Enable controls and re-open the ClientDataSet
    ClientDataSet1.EnableControls;
    ClientDataSet1.Open;
    //Hook up the CUSTNO OnGetText event handler
    ClientDataSet1.FieldByName('CUSTNO').OnGetText :=
      ClientDataSet1CustNoGetText;
  end;
end;

end.
