(* Copyright (c) 2011 - 2015. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets"
     and
   "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook2
*)
unit dynamicform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls, DBCtrls, Grids, DBGrids, DBClient, Provider,
  FireDAC.Comp.Client,
  FireDAC.Comp.DataSet,
  FireDAC.Comp.UI,
  FireDAC.DApt,
  FireDAC.DApt.Intf,
  FireDAC.DatS,
  FireDAC.Phys,
  FireDAC.Phys.IB,
  FireDAC.Phys.IBBase,
  FireDAC.Phys.Intf,
  FireDAC.Stan.Async,
  FireDAC.Stan.Def,
  FireDAC.Stan.Error,
  FireDAC.Stan.Intf,
  FireDAC.Stan.Option,
  FireDAC.Stan.Param,
  FireDAC.Stan.Pool,
  FireDAC.UI.Intf,
  {$IF CompilerVersion < 28}
  // nothing needed
  {$ELSE}
  FireDAC.Phys.IBDef,
  {$ENDIF}
  FireDAC.VCLUI.Wait;

type
  TRuntimeForm = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RuntimeForm: TRuntimeForm;

implementation

uses main;

{$R *.dfm}

procedure TRuntimeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  //Enable the menu item used to create this form
    Form1.RuntimeConfiguration1.Enabled := True;
end;

procedure TRuntimeForm.FormCreate(Sender: TObject);
var
  CDS: TClientDataSet;
  DSP: TDataSetProvider;
  FDConnection: TFDConnection;
  FDQuery: TFDQuery;
begin
  //When configuring a ClientDataSet and
  //DataSetProvider using the ClientDataSet's
  //ProviderName, both must have the same owner,
  //and the DataSetProvider must have a name.
  // or
  //You need to hook the ClientDataSet to the a
  //DataSetProvider using TClientDataSet.SetProvider
  FDConnection := TFDConnection.Create(Self);
  FDQuery := TFDQuery.Create(Self);
  FDQuery.Connection := FDConnection;
  FDConnection.Params.Clear;
  FDConnection.Params.Add('DriverID=IB');
  FDConnection.Params.Add('Database=' +
    GetEnvironmentVariable('DEMOSDIR') + 'Data\dbdemos.gdb');
  FDConnection.Params.Add('User_Name=sysdba');
  FDConnection.Params.Add('password=masterkey');
  FDConnection.Params.Add('Server=localhost');
  FDConnection.LoginPrompt := False;
  FDQuery.SQL.Text := 'SELECT * FROM Items';
  FDQuery.Open;

  CDS := TClientDataSet.Create(Self);
  DSP := TDataSetProvider.Create(Self);
  DSP.Name := 'DSP1';
  CDS.ProviderName := DSP.Name;
  DSP.DataSet := FDQuery;
  CDS.Open;
  DataSource1.DataSet := CDS;
  //Disable the menu item used to create this form
  Form1.RuntimeConfiguration1.Enabled := False;
end;

end.
