(* Copyright (c) 2011 - 2015. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets"
     and
   "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook2
*)
unit mainformu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Datasnap.DBClient,
  Vcl.StdCtrls, Vcl.Grids, Vcl.DBGrids, Vcl.DBCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button1: TButton;
    ListBox1: TListBox;
    ClientDataSet1: TClientDataSet;
    Panel2: TPanel;
    Splitter1: TSplitter;
    UseClonedCursor: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ShowSelectedWithClone;
    procedure ShowSelectedWithoutClone;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListBox1.Clear;
  if UseClonedCursor.Checked then
    ShowSelectedWithClone
  else
    ShowSelectedWithoutClone;
end;

procedure TForm1.ShowSelectedWithClone;
var
  cds: TClientDataSet;
  i: Integer;
begin
  cds := TClientDataSet.Create(nil);
  try
    cds.CloneCursor(ClientDataSet1, True);
    if DBGrid1.SelectedRows.Count > 0 then
    try
      for i := 0 to DBGrid1.SelectedRows.Count -1 do
      begin
        cds.GotoBookmark(DBGrid1.SelectedRows[i]);
        listbox1.Items.Add(cds.Fields[0].AsString);
      end;
    finally
    end;
  finally
    cds.Free;
  end;
end;

procedure TForm1.ShowSelectedWithoutClone;
var
  Bookmark: TBookmark;
  i: Integer;
begin
  if DBGrid1.SelectedRows.Count = 0 then exit;
  Bookmark := ClientDataSet1.GetBookmark;
  ClientDataSet1.DisableControls;
  try
    for i := 0 to DBGrid1.SelectedRows.Count -1 do
    begin
      ClientDataSet1.GotoBookmark(DBGrid1.SelectedRows[i]);
      listbox1.Items.Add(ClientDataSet1.Fields[0].AsString);
    end;
  finally
    ClientDataSet1.GotoBookmark(Bookmark);
    ClientDataSet1.EnableControls;
  end;
end;

end.
